Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.tools
Interface JavaFileManager

All Superinterfaces:
  Closeable, Flushable, OptionChecker

All Known Subinterfaces:
  StandardJavaFileManager

All Known Implementing Classes:
  ForwardingJavaFileManager

    public interface JavaFileManager

extends Closeable, Flushable, OptionChecker

File manager for tools operating on Java™ programming language source and class files. In this context, file means an abstraction of regular files and other sources of data.

When constructing new JavaFileObjects, the file manager must determine where to create them. For example, if a file manager manages regular files on a file system, it would most likely have a current/working directory to use as default location when creating or finding files. A number of hints can be provided to a file manager as to where to create files. Any file manager might choose to ignore these hints.

Some methods in this interface use class names. Such class names must be given in the Java Virtual Machine internal form of fully qualified class and interface names. For convenience '.' and '/' are interchangeable. The internal form is defined in chapter four of the Java Virtual Machine Specification.

> Discussion: this means that the names "java/lang.package-info", "java/lang/package-info", "java.lang.package-info", are valid and equivalent. Compare to binary name as defined in the Java Language Specification (JLS) section 13.1 "The Form of a Binary".

The case of names is significant. All names should be treated as case-sensitive. For example, some file systems have case-insensitive, case-aware file names. File objects representing such files should take care to preserve case by using `File.getCanonicalFile()` or similar means. If the system is not case-aware, file objects must use other means to preserve case.

Relative names: some methods in this interface use relative names. A relative name is a non-null, non-empty sequence of path segments separated by '/'. '.' or '..' are invalid path segments. A valid relative name must match the "path-rootless" rule of RFC 3986, section 3.3. Informally, this should be true:

      URI.create(relativeName).normalize().getPath().equals(relativeName)

All methods in this interface might throw a SecurityException.

An object of this interface is not required to support multi-threaded access, that is, be synchronized. However, it must support concurrent access to different file objects created by this object.

Implementation note: a consequence of this requirement is that a trivial implementation of output to a JarOutputStream is not a sufficient implementation. That is, rather than creating a JavaFileObject that returns the JarOutputStream directly, the contents must be cached until closed and then written to the JarOutputStream.

Unless explicitly allowed, all methods in this interface might throw a NullPointerException if given a `null` argument.

Since:
  1.6
See Also:
  `JavaFileObject`, `FileObject`

Nested Class Summary
`static interface` | `JavaFileManager.Location` Interface for locations of file objects.

Method Summary
`void` | `close()` Releases any resources opened by this file manager directly or indirectly.
`void` | `flush()` Flushes any resources opened for output by this file manager directly or indirectly.
`ClassLoader` | `getClassLoader(JavaFileManager.Location location)` Gets a class loader for loading plug-ins from the given location.
`FileObject` | `getFileForInput(JavaFileManager.Location location, String packageName, String relativeName)` Gets a file object for input representing the specified relative name in the specified package in the given location.
`FileObject` | `getFileForOutput(JavaFileManager.Location location, String packageName, String relativeName, FileObject sibling)` Gets a file object for output representing the specified relative name in the specified package in the given location.
`JavaFileObject` | `getJavaFileForInput(JavaFileManager.Location location, String className, JavaFileObject.Kind kind)` Gets a file object for input representing the specified class of the specified kind in the given location.
`JavaFileObject` | `getJavaFileForOutput(JavaFileManager.Location location, String className, JavaFileObject.Kind kind, FileObject sibling)` Gets a file object for output representing the specified class of the specified kind in the given location.
`boolean` | `handleOption(String current, Iterator<String> remaining)` Handles one option.
`boolean` | `hasLocation(JavaFileManager.Location location)` Determines if a location is known to this file manager.
`String` | `inferBinaryName(JavaFileManager.Location location, JavaFileObject file)` Infers a binary name of a file object based on a location.
`boolean` | `isSameFile(FileObject a, FileObject b)` Compares two file objects and return true if they represent the same underlying object.
`Iterable<JavaFileObject>` | `list(JavaFileManager.Location location, String packageName, Set<JavaFileObject.Kind> kinds, boolean recurse)` Lists all file objects matching the given criteria in the given location.

Methods inherited from interface javax.tools.OptionChecker
`isSupportedOption`

Method Detail

### getClassLoader

    ClassLoader getClassLoader(JavaFileManager.Location location)

  Gets a class loader for loading plug-ins from the given location. For example, to load annotation processors, a compiler will request a class loader for the `ANNOTATION_PROCESSOR_PATH` location.

  Parameters:
    `location` - a location
  Returns:
    a class loader for the given location; or `null` if loading plug-ins from the given location is disabled or if the location is not known
  Throws:
    `SecurityException` - if a class loader can not be created in the current security context
    `IllegalStateException` - if `close()` has been called and this file manager cannot be reopened

### list

    Iterable<JavaFileObject> list(JavaFileManager.Location location,
                                  String packageName,
                                  Set<JavaFileObject.Kind> kinds,
                                  boolean recurse)
                                  throws IOException

  Lists all file objects matching the given criteria in the given location. List file objects in "subpackages" if recurse is true.

  Note: even if the given location is unknown to this file manager, it may not return `null`. Also, an unknown location may not cause an exception.

  Parameters:
    `location` - a location
    `packageName` - a package name
    `kinds` - return objects only of these kinds
    `recurse` - if true include "subpackages"
  Returns:
    an Iterable of file objects matching the given criteria
  Throws:
    `IOException` - if an I/O error occurred, or if `close()` has been called and this file manager cannot be reopened
    `IllegalStateException` - if `close()` has been called and this file manager cannot be reopened

### inferBinaryName

    String inferBinaryName(JavaFileManager.Location location,
                           JavaFileObject file)

  Infers a binary name of a file object based on a location. The binary name returned might not be a valid JLS binary name.

  Parameters:
    `location` - a location
    `file` - a file object
  Returns:
    a binary name or `null` the file object is not found in the given location
  Throws:
    `IllegalStateException` - if `close()` has been called and this file manager cannot be reopened

### isSameFile

    boolean isSameFile(FileObject a,
                       FileObject b)

  Compares two file objects and return true if they represent the same underlying object.

  Parameters:
    `a` - a file object
    `b` - a file object
  Returns:
    true if the given file objects represent the same underlying object
  Throws:
    `IllegalArgumentException` - if either of the arguments were created with another file manager and this file manager does not support foreign file objects

### handleOption

    boolean handleOption(String current,
                         Iterator<String> remaining)

  Handles one option. If `current` is an option to this file manager it will consume any arguments to that option from `remaining` and return true, otherwise return false.

  Parameters:
    `current` - current option
    `remaining` - remaining options
  Returns:
    true if this option was handled by this file manager, false otherwise
  Throws:
    `IllegalArgumentException` - if this option to this file manager is used incorrectly
    `IllegalStateException` - if `close()` has been called and this file manager cannot be reopened

### hasLocation

    boolean hasLocation(JavaFileManager.Location location)

  Determines if a location is known to this file manager.

  Parameters:
    `location` - a location
  Returns:
    true if the location is known

### getJavaFileForInput

    JavaFileObject getJavaFileForInput(JavaFileManager.Location location,
                                       String className,
                                       JavaFileObject.Kind kind)
                                       throws IOException

  Gets a file object for input representing the specified class of the specified kind in the given location.

  Parameters:
    `location` - a location
    `className` - the name of a class
    `kind` - the kind of file, must be one of `SOURCE` or `CLASS`
  Returns:
    a file object, might return `null` if the file does not exist
  Throws:
    `IllegalArgumentException` - if the location is not known to this file manager and the file manager does not support unknown locations, or if the kind is not valid
    `IOException` - if an I/O error occurred, or if `close()` has been called and this file manager cannot be reopened
    `IllegalStateException` - if `close()` has been called and this file manager cannot be reopened

### getJavaFileForOutput

    JavaFileObject getJavaFileForOutput(JavaFileManager.Location location,
                                        String className,
                                        JavaFileObject.Kind kind,
                                        FileObject sibling)
                                        throws IOException

  Gets a file object for output representing the specified class of the specified kind in the given location.

  Optionally, this file manager might consider the sibling as a hint for where to place the output. The exact semantics of this hint is unspecified. Sun's compiler, javac, for example, will place class files in the same directories as originating source files unless a class file output directory is provided. To facilitate this behavior, javac might provide the originating source file as sibling when calling this method.

  Parameters:
    `location` - a location
    `className` - the name of a class
    `kind` - the kind of file, must be one of `SOURCE` or `CLASS`
    `sibling` - a file object to be used as hint for placement; might be `null`
  Returns:
    a file object for output
  Throws:
    `IllegalArgumentException` - if sibling is not known to this file manager, or if the location is not known to this file manager and the file manager does not support unknown locations, or if the kind is not valid
    `IOException` - if an I/O error occurred, or if `close()` has been called and this file manager cannot be reopened
    `IllegalStateException` - `close()` has been called and this file manager cannot be reopened

### getFileForInput

    FileObject getFileForInput(JavaFileManager.Location location,
                               String packageName,
                               String relativeName)
                               throws IOException

  Gets a file object for input representing the specified relative name in the specified package in the given location.

  If the returned object represents a source or class file, it must be an instance of `JavaFileObject`.

  Informally, the file object returned by this method is located in the concatenation of the location, package name, and relative name. For example, to locate the properties file "resources/compiler.properties" in the package "com.sun.tools.javac" in the SOURCE_PATH location, this method might be called like so:

      getFileForInput(SOURCE_PATH, "com.sun.tools.javac", "resources/compiler.properties");

  If the call was executed on Windows, with SOURCE_PATH set to `"C:\Documents and Settings\UncleBob\src\share\classes"`, a valid result would be a file object representing the file `"C:\Documents and Settings\UncleBob\src\share\classes\com\sun\tools\javac\resources\compiler.properties"`.

  Parameters:
    `location` - a location
    `packageName` - a package name
    `relativeName` - a relative name
  Returns:
    a file object, might return `null` if the file does not exist
  Throws:
    `IllegalArgumentException` - if the location is not known to this file manager and the file manager does not support unknown locations, or if `relativeName` is not valid
    `IOException` - if an I/O error occurred, or if `close()` has been called and this file manager cannot be reopened
    `IllegalStateException` - if `close()` has been called and this file manager cannot be reopened

### getFileForOutput

    FileObject getFileForOutput(JavaFileManager.Location location,
                                String packageName,
                                String relativeName,
                                FileObject sibling)
                                throws IOException

  Gets a file object for output representing the specified relative name in the specified package in the given location.

  Optionally, this file manager might consider the sibling as a hint for where to place the output. The exact semantics of this hint is unspecified. Sun's compiler, javac, for example, will place class files in the same directories as originating source files unless a class file output directory is provided. To facilitate this behavior, javac might provide the originating source file as sibling when calling this method.

  If the returned object represents a source or class file, it must be an instance of `JavaFileObject`.

  Informally, the file object returned by this method is located in the concatenation of the location, package name, and relative name or next to the sibling argument. See `getFileForInput` for an example.

  Parameters:
    `location` - a location
    `packageName` - a package name
    `relativeName` - a relative name
    `sibling` - a file object to be used as hint for placement; might be `null`
  Returns:
    a file object
  Throws:
    `IllegalArgumentException` - if sibling is not known to this file manager, or if the location is not known to this file manager and the file manager does not support unknown locations, or if `relativeName` is not valid
    `IOException` - if an I/O error occurred, or if `close()` has been called and this file manager cannot be reopened
    `IllegalStateException` - if `close()` has been called and this file manager cannot be reopened

### flush

    void flush()
               throws IOException

  Flushes any resources opened for output by this file manager directly or indirectly. Flushing a closed file manager has no effect.

  Specified by:
    `flush` in interface `Flushable`
  Throws:
    `IOException` - if an I/O error occurred
  See Also:
    `close()`

### close

    void close()
               throws IOException

  Releases any resources opened by this file manager directly or indirectly. This might render this file manager useless and the effect of subsequent calls to methods on this object or any objects obtained through this object is undefined unless explicitly allowed. However, closing a file manager which has already been closed has no effect.

  Specified by:
    `close` in interface `Closeable`
  Throws:
    `IOException` - if an I/O error occurred
  See Also:
    `flush()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2009 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.